SystemOrganization addCategory: #PharoKernel!

Object subclass: #PharoKernel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoKernel'!

!PharoKernel methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:45'!
downloadPackagesNamed: listOfPackageNames fromRepositoryNamed: aRepositoryName

	ZnConnectionTimeout value: 300 during: [
	listOfPackageNames do: [:packageName |
	  FileStream forceNewFileNamed: (packageName, '.st') do: [:file |
	    file nextPutAll: (ScriptLoader latestSource: packageName location: aRepositoryName)]].
	].

	
	
	! !

!PharoKernel methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:21'!
installPackagesNamed: aListOfPackageNames
	(aListOfPackageNames collect: [:each | each , '.st']) 
		do: [:each | FileStream readOnlyFileNamed: each do: [:file | file fileInSilently ].]
	! !

!PharoKernel methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:19'!
loadPackagesNamed: aListOfPackageNames fromRepositoryNamed: aRepositoryName
	
	self downloadPackagesNamed: aListOfPackageNames fromRepositoryNamed: aRepositoryName.
	self installPackagesNamed: aListOfPackageNames.
	! !

!PharoKernel methodsFor: 'logging' stamp: 'MarianoMartinezPeck 4/28/2012 12:27'!
log: aString
	FileStream stdout lf; nextPutAll: aString; lf.! !

PharoKernel subclass: #PharoKernelExporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoKernel'!

!PharoKernelExporter class methodsFor: 'instance-creation' stamp: 'MarianoMartinezPeck 4/28/2012 12:11'!
exportCore
	self new exportCore! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 12:29'!
exportCore
	self loadFuel.
	self serializeClassVariablesAndFonts.
	self exportRing.
	self exportGofer.
	self exportPharoCore.
	self saveImageAndQuite.! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 12:31'!
exportPackagesNamed: packageNames toFileName: aFileName
	FileStream forceNewFileNamed: aFileName do: [:aStream |
       aStream binary.
       FLPackageStore new storeOn: aStream packages: packageNames.].
! !

!PharoKernelExporter methodsFor: 'exporting' stamp: 'MarianoMartinezPeck 4/28/2012 12:31'!
exportRing

	| packageNames |
	packageNames := 'Ring-Core-Containers 
	Ring-Core-Kernel' lines.
	self log: 'Exporting Ring packages'.
	self exportPackagesNamed: packageNames toFileName: 'ring.fuel'.
	self log: 'Finished'.! !

!PharoKernelExporter methodsFor: 'loading' stamp: 'MarianoMartinezPeck 4/28/2012 12:26'!
loadFuel
	self log: 'Loading and installing Fuel from repository'.
	self loadPackagesNamed:  #( 'Fuel' 'FuelMetalevel' 'FuelPackageLoader') fromRepositoryNamed: 'http://ss3.gemstone.com/ss/Fuel'.
	self log: 'Finished'.
	
	! !

!PharoKernelExporter methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 4/28/2012 12:24'!
serialize: anObject toFileNamed: aFileName
	FLSerializer serialize: anObject toFileNamed: aFileName.! !

!PharoKernelExporter methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 4/28/2012 12:26'!
serializeClassVariablesAndFonts
	self log: 'Serializing class variables and fonts'.
	self serialize: (TextStyle named: 'Bitmap DejaVu Sans') toFileNamed: 'dejavu.fuel'.
	self serialize: (Unicode classPool at: #DecimalProperty) toFileNamed: 'decimalProperty.fuel'.
	self serialize: (Unicode classPool at: #GeneralCategory) toFileNamed: 'generalCategory.fuel'.
	self serialize: (UCSTable classPool at: #GB2312Table) toFileNamed: 'gb2312Table.fuel'.
	self serialize: (UCSTable classPool at: #JISX0208Table) toFileNamed: '#jisX0208Table.fuel'.
	self serialize: (UCSTable classPool at: #KSX1001Table) toFileNamed: '#ksx1001Table.fuel'.
	self log: 'Finished'.! !

!PackageInfo methodsFor: '*PharoKernel' stamp: 'MarianoMartinezPeck 4/28/2012 12:12'!
extensionMethods
	^ (Smalltalk allClassesAndTraits, (Smalltalk allClasses collect: [:c | c class])) gather: [:classOrTrait | self extensionMethodsForClass: classOrTrait]! !
